package de.fsd.bean;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.faces.model.SelectItem;

import org.richfaces.model.Ordering;
import org.richfaces.model.selection.Selection;
import org.richfaces.model.selection.SimpleSelection;

import de.fsd.domain.ColumnConfigurationVO;
import de.fsd.domain.ConfigurationVO;
import de.fsd.service.ConfigurationServiceImpl;
import de.fsd.service.DatabaseServiceImpl;

/**
 * This class is the control for the searchModul
 * @author eugenbesel
 * www.besel-it.de
 */
public class SearchModulBBean {
	
	private List<ArrayList<String>> dataList = new ArrayList<ArrayList<String>>();
	ConfigurationVO confVO;
	private Object tableState;
	private Selection selection = new SimpleSelection();
	private Map<String, Ordering> sortOrders = new HashMap<String, Ordering>();
	private Map<String, Object> columnFilterValues = new HashMap<String, Object>();
    private String firstColumn="";
    private int columnCount=1;
    private ArrayList<SelectItem> selectItem = new ArrayList<SelectItem>();
//    private Map<String, Object> renderFields = new HashMap<String, Object>();
    
    
    
    String comboColumn = "";
    String textFilter ="";
    
	public Map<String, Object> getColumnFilterValues() {
		return columnFilterValues;
	}

	public void setColumnFilterValues(Map<String, Object> columnFilterValues) {
		this.columnFilterValues = columnFilterValues;
	}

	public Map<String, Ordering> getSortOrders() {
		return sortOrders;
	}

	public void setSortOrders(Map<String, Ordering> sortOrders) {
		this.sortOrders = sortOrders;
	}

	// when the bean is instantiated, then initialize the data for display
	public SearchModulBBean(){
		init();
	}
	
	/**
	 * initialization of data. set default sort criteria
	 */
	public void init(){
		ConfigurationServiceImpl conf = new ConfigurationServiceImpl();
		confVO = conf.getConfiguration();
		DatabaseServiceImpl service = new DatabaseServiceImpl();
	    dataList = service.getValuesFromDatabase(confVO);
	    for(ColumnConfigurationVO columnsIter : confVO.getColumns()){
			if("true".equals(columnsIter.getSortselected())){	
				if(sortOrders.get(columnsIter.getCaption())==null){
					sortOrders.put(columnsIter.getCaption(), Ordering.ASCENDING);
				}else{
					
				}
			}
		}
//	    comboColumn+= confVO.getColumns().get(0).getCaption();
//	    comboColumn+= confVO.getColumns().get(1).getCaption();
	    textFilter +=confVO.getColumns().get(2).getCaption();
	    textFilter +=confVO.getColumns().get(3).getCaption();
	    for (int i = 5; i < 11; i++) {
			SelectItem select = new SelectItem();
			select.setLabel("-" + i);
			select.setValue(i);
			selectItem.add(select);
		}
	}
	
	/**
	 * get the information about table header
	 * @return
	 */
	public String getTableHeader(){
		return confVO.getTitel();
	}

	
	/**
	 * this method create the data values for displaing n GUI 
	 * @return
	 */
	public List<ArrayList<String>> getColumnData(){
		return dataList;
	}
	
	public int getSize(){
		return dataList.size();
	}
	
	
	public Object getTableState() {
		return tableState;
	}

	public void setTableState(Object tableState) {
		this.tableState = tableState;
	}

	public Selection getSelection() {
		return selection;
	}

	public void setSelection(Selection selection) {
		this.selection = selection;
	}
	
	/**
	 * this method filter the data of the table
	 * @param current
	 * @return
	 */
	public boolean filterData(Object current) {
		if(current==null){
			return false;
		}
		List<String> rows = (ArrayList<String>)current;
		if(!columnFilterValues.keySet().isEmpty()){
			Iterator<String> iter = columnFilterValues.keySet().iterator();
			boolean toFilter=false;
			List searchIndex = new ArrayList();
			int index=0;
			// hole originale geordnete Liste von Spalten
			List<String> columnsOrig = getColumns();
			// da die Liste der Filter nicht geordnet ist, suche passende Spalte
			while(iter.hasNext()){
				index=0;
				String key = iter.next();
				String filter = (String)columnFilterValues.get(key);
				if(filter!=null && !filter.equals("")){
					toFilter=true;
					for(String columnIn : columnsOrig){
						if(columnIn.equals(key)){
							if(!rows.get(index).startsWith(filter)){
								return false;
							}	
							
						}
						index++;
					}
				}
			}
			
			
		}
//		System.out.println(current.toString());
		return true;
	}
	
	public boolean filterData(String current) {
		if(current==null){
			return false;
		}
		return true;
	}
	
	public String getFirstColumn(){
		return firstColumn;
	}
	public String getColumnCount(){
		return confVO.getColumns().size()+"";
	}
	
	
	/**
	 * this method create the Array for Columns
	 * @return
	 */
	public List<String> getColumns(){
		columnCount=0;
		List<String> columns = new ArrayList<String>();
//		firstColumn = confVO.getColumns().get(0).getCaption();
		
		for(int i=0; i < confVO.getColumns().size();i++){
			columns.add(confVO.getColumns().get(i).getCaption());
			columnCount++;
		}
		
		
		return columns;
	}

	public String getComboColumn() {
		return comboColumn;
	}

	public void setComboColumn(String comboColumn) {
		this.comboColumn = comboColumn;
	}

	public String getTextFilter() {
		return textFilter;
	}

	public void setTextFilter(String textFilter) {
		this.textFilter = textFilter;
	}

	public ArrayList<SelectItem> getSelectItem() {
		return selectItem;
	}

	public void setSelectItem(ArrayList<SelectItem> selectItem) {
		this.selectItem = selectItem;
	}
	
	/*
	public void takeSelection(){
		selectedCapitals.clear();
		Iterator<Object> iterator = getSelection().getKeys();
		while (iterator.hasNext()) {
			Object key = iterator.next();
			selectedCapitals.add(getCapitalsDataModel().getObjectByKey(key));
		}
	}*/
}
